#ifndef _UTILNT_H
#define _UTILNT_H

char *strtok_r(char *s1, char *s2, char **lasts);
double drand48();
int getopt(int nargc, char * const *nargv, const char *ostr);

/*
 * gettimeofday() function
 * Used in gettimeofdayf.c, error.c
 */
int gettimeofday(struct timeval *tp, void * );

/*
 * For syslog, openlog, closelog functions
 * Used in error.c
 */

void closelog(void);
void openlog(const char *ident, int logopt, int facility);
void syslog(int priority, const char *message, ... /* arguments */);

/*
 * struct group *getgrnam(const char *name) funciton
 * Used in gname2id.c
 */
typedef long    pid_t;					/* PID type				*/
typedef long    uid_t;                  /* UID type             */
typedef uid_t   gid_t;                  /* GID type             */

#ifndef _GROUP_T_
#define _GROUP_T_
struct  group { /* see getgrent(3) */
        char    *gr_name;
        char    *gr_passwd;
        gid_t   gr_gid;
        char    **gr_mem;
};
#endif 
int uname(struct utsname *name);

long gethostid(void);

long getuid(void);

long getgid(void);

int pthread_create(HANDLE *new_thread_ID, const void *attr, void * (*start_func)(void *), void *arg);

struct group *getgrnam(const char *name);

struct passwd *getpwnam(const char *name);

struct passwd *getpwuid(uid_t uid);

#endif
