# Columbia servers, makefile fragment for Win32 environment.
# Copyright 1998-2000 by Columbia University; all rights reserved 

win32_dir := NT

WIN32_SRC := \
  $(win32_dir)/crypt/crypt.c \
  $(win32_dir)/regex/regcomp.c \
  $(win32_dir)/regex/regerror.c \
  $(win32_dir)/regex/regexec.c \
  $(win32_dir)/regex/regfree.c \
  $(win32_dir)/yp/yplib.c \
  $(win32_dir)/getopt.c  \
  $(win32_dir)/resparse-1.3/bzero.c         \
  $(win32_dir)/resparse-1.3/inet_addr.c     \
  $(win32_dir)/resparse-1.3/memset.c        \
  $(win32_dir)/resparse-1.3/res_init.c \
  $(win32_dir)/resparse-1.3/ns_name.c       \
  $(win32_dir)/resparse-1.3/res_mkquery.c \
  $(win32_dir)/resparse-1.3/ns_netint.c     \
  $(win32_dir)/resparse-1.3/res_comp.c      \
  $(win32_dir)/resparse-1.3/res_query.c \
  $(win32_dir)/resparse-1.3/res_data.c      \
  $(win32_dir)/resparse-1.3/res_send.c \
  $(win32_dir)/utilNT.c \
  $(win32_dir)/monitor/service.c \
  $(win32_dir)/monitor/sipd_monitor.c



# Headers are taken from include, include/*,
# include/utilNT/*

WIN32_HEADERS := \
  $(win32_dir)/include/grp.h \
  $(win32_dir)/include/netdb.h \
  $(win32_dir)/include/nterrno.h \
  $(win32_dir)/include/pthread.h \
  $(win32_dir)/include/pwd.h \
  $(win32_dir)/include/regex.h \
  $(win32_dir)/include/resolv.h \
  $(win32_dir)/include/syslog.h \
  $(win32_dir)/include/unistd.h \
  $(win32_dir)/include/arpa/inet.h \
  $(win32_dir)/include/arpa/nameser.h \
  $(win32_dir)/include/netinet/in.h \
  $(win32_dir)/include/rpcsvc/ypclnt.h \
  $(win32_dir)/include/dirent.h \
  $(win32_dir)/regex/utils.h \
  $(win32_dir)/regex/regex.h \
  $(win32_dir)/regex/cname.h \
  $(win32_dir)/regex/cclass.h \
  $(win32_dir)/regex/regex2.h \
  $(win32_dir)/regex/engine.c \
  $(win32_dir)/include/sys/errno.h \
  $(win32_dir)/include/sys/isa_defs.h \
  $(win32_dir)/include/sys/param.h \
  $(win32_dir)/include/sys/socket.h \
  $(win32_dir)/include/sys/systeminfo.h \
  $(win32_dir)/include/sys/time.h \
  $(win32_dir)/include/sys/uio.h \
  $(win32_dir)/include/sys/usname.h \
  $(win32_dir)/include/sys/utsname.h \
  $(win32_dir)/include/sys/wait.h \
  $(win32_dir)/resparse-1.3/rr.h \
  $(win32_dir)/include/utilNT/bzero.h \
  $(win32_dir)/include/utilNT/crypt.h \
  $(win32_dir)/include/utilNT/extern.h \
  $(win32_dir)/include/utilNT/getopt.h \
  $(win32_dir)/include/utilNT/inet_aton.h \
  $(win32_dir)/include/utilNT/libgen.h \
  $(win32_dir)/include/utilNT/ns.h \
  $(win32_dir)/include/utilNT/ns_name.h \
  $(win32_dir)/include/utilNT/poll.h \
  $(win32_dir)/include/utilNT/proto.h \
  $(win32_dir)/include/utilNT/res_config.h \
  $(win32_dir)/include/utilNT/res_info.h \
  $(win32_dir)/include/utilNT/res_signal.h \
  $(win32_dir)/include/utilNT/sol_search.h \
  $(win32_dir)/include/utilNT/systems.h \
  $(win32_dir)/include/utilNT/utilNT.h \
  $(win32_dir)/monitor/service.h \

WIN32_MISC := \
  $(win32_dir)/README.win32 \
  $(win32_dir)/module.mk \
  $(win32_dir)/ntutil.dsp \
  $(win32_dir)/libdbapi_nosql.dsp \
  $(win32_dir)/libsip_nosql.dsp \
  $(win32_dir)/libsipapi_nosql.dsp \
  $(win32_dir)/regex/COPYRIGHT \
  $(win32_dir)/monitor/sipd_service.dsp \
  $(win32_dir)/monitor/sipd_service.dsw

WIN32_MISCDIST := \
  $(win32_dir)/resparse-1.3/resolv.conf \
  $(win32_dir)/monitor/README

WIN32_BIN := \
  $(win32_dir)/monitor/Debug/sipd_service.exe \
  $(win32_dir)/monitor/Release/sipd_service.exe

# SRC       += $(WIN32_SRC)
# HEADERS   += $(WIN32_HEADERS)

WIN32_DIST := $(WIN32_SRC) $(WIN32_MAYBESRC) $(WIN32_HEADERS) \
	$(WIN32_MISC) $(WIN32_MISCDIST)

WIN32_BINDIST :=  $(WIN32_MISCDIST)

win32-dist: $(WIN32_DIST)





