/* service.h : Install and Manage a Win32 service.
 * 2001. Columbia University. All rights reserved.
 */

/* Parts of this code come under the following license:
 *
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
//
// Copyright (C) 1993-1997  Microsoft Corporation.  All Rights Reserved.
//
//  There is no need to modify the code in service.c.  Just add service.c
//  to your project and link with the following libraries...
//
//  libcmt.lib kernel32.lib advapi.lib shell32.lib
//
//
//  Upon completion, your code will have the following command line interface
//
//  <service exe> -?                to display this list
//  <service exe> -install          to install the service
//  <service exe> -remove           to remove the service
//  <service exe> -debug <params>   to run as a console app for debugging
//
//        To control your service ( start, stop, etc ) you may use the
//        Services control panel applet or the NET.EXE program.
//
*/

#ifndef _SERVICE_H
#define _SERVICE_H

// name of the executable
#define SZAPPNAME            "Sipd_Monitor"

// internal name of the service
#define SZSERVICENAME        "Sipd_Monitor"

// displayed name of the service
#define SZSERVICEDISPLAYNAME "Sipd run monitor"

#define SZDEPENDENCIES ""

extern void RunSipd();
extern void ServiceStop();


/* ReportStatusToSCMgr()
 *   Sets the current status of the service and reports it to the Win32 SCM.
 * Parameters:
 *    dwCurrentState - the state of the service
 *    dwWin32ExitCode - error code to report
 *    dwWaitHint - worst case estimate to next checkpoint
 * Return Value:
 *  TRUE or FALSE
*/
extern BOOL ReportStatusToSCMgr(DWORD dwCurrentState, 
                         DWORD dwWin32ExitCode, DWORD dwWaitHint);


/* AddToMessageLog
 *  Allows any thread to an error message to the Win32 system error log.
*/
extern void AddToMessageLog(LPTSTR lpszMsg);

#endif
