dnl Special autoconf tests sipd needs
dnl Copyright 1999-2000 by Columbia University; all rights reserved 

dnl CU_CHECK_LIB
dnl Slight generalization of AC_CHECK_LIB.  The idea is that rather than
dnl stick the library to link in into the generic LIBS dir, we stick it in
dnl the variable specified.
AC_DEFUN(CU_CHECK_LIB,
[AC_CHECK_LIB($1, $2,
 [changequote(, )dnl
  ac_tr_lib=HAVE_LIB`echo $1 | sed -e 's/[^a-zA-Z0-9_]/_/g' \
    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
changequote([, ])dnl
  AC_DEFINE_UNQUOTED($ac_tr_lib)
  $3="-l$1 [$]$3"
  AC_SUBST($3)dnl
 ], $4, [$]$3 $5)dnl
])

dnl CU_WARN_NOT_PRESENT
dnl Issue a warning if a package isn't present, giving a URL
dnl where it can be obtained.
AC_DEFUN(CU_WARN_NOT_PRESENT,
[echo;
AC_MSG_WARN([$1.
Some components may require this package.
If you have build problems[,] please obtain it from
$3[,]
then tell configure where you installed it using --with-$2=\$dir.
])])

dnl CU_WARN_NOT_TESTED
dnl Issue a warning if a package isn't tested.
AC_DEFUN(CU_WARN_NOT_TESTED,
[echo;
AC_MSG_WARN([$1.
Please make sure that this package is compiled and
works for this platform and machine.
If you have build problems[,] please see
$3.])])

dnl CU_CHECK_PACKAGE
dnl Check if a given package is installed, and if the user wants it to
dnl be used.  Variables USE_<PACKAGE> and <PACKAGE>LIBS get defined.
dnl Arguments:
dnl 1: package name as capitalized token (all alphanum and _), for USE_
dnl 2: package name as lower-case token (all alphanum and _), for --with
dnl 3: package name, user-comprehensible form
dnl 4: name of library for package
dnl 5: name of function in library
dnl 6: URL of package
dnl 7: required other libraries (passed to $5 of CU_CHECK_LIB)
dnl 8: optional subdir of lib and include dirs (MySQL hack)

AC_DEFUN(CU_CHECK_PACKAGE,
[AC_ARG_WITH($2,
[  --with-$2=\$dir          use $3, with library and includes in \$dir],
        $1_DIR=$withval)
if test "x[$]$1_DIR" != "x"; then
        AC_MSG_CHECKING(whether to use $3)
        if test "x[$]$1_DIR" != "xno"; then
                cu_cv_use_$2="yes"
        else
                cu_cv_use_$2="no"
        fi
        AC_MSG_RESULT($cu_cv_use_$2)
else
        AC_CACHE_CHECK(whether to use $3, cu_cv_use_$2,
                cu_cv_use_$2="no")
fi
USE_$1=$cu_cv_use_$2
AC_SUBST(USE_$1)
if test "x$5" != "x"; then
if test "x$cu_cv_use_$2" != "xno"; then
        if test "x[$]$1_DIR" != "xyes" -a "x[$]$1_DIR" != "x"; then
                AC_MSG_CHECKING(directory for $3)
                cu_cv_$2_dir=[$]$1_DIR
                AC_MSG_RESULT([$]cu_cv_$2_dir)
                unset ac_cv_lib_$4_$5
        else
                AC_CACHE_CHECK(directory for $3, cu_cv_$2_dir,
                        cu_cv_$2_dir="unknown")
        fi
        if test "x$cu_cv_$2_dir" != "xunknown"; then
                CPPFLAGS="$CPPFLAGS -I$cu_cv_$2_dir/include"
                LDFLAGS="$LDFLAGS -L$cu_cv_$2_dir/lib"
                cu_$2_libdir="$cu_cv_$2_dir/lib"
ifelse([$8], , , dnl
[                CPPFLAGS="$CPPFLAGS -I$cu_cv_$2_dir/include/$8"
                LDFLAGS="$LDFLAGS -L$cu_cv_$2_dir/lib/$8"
                cu_$2_libdir="$cu_$2_libdir $cu_cv_$2_dir/lib/$8"
])dnl
        fi
        CU_CHECK_LIB($4, $5, $1LIBS,
                [[CU_WARN_NOT_PRESENT([Could not find $3], $2, $6)]], $7)
        if test "x[$]$1LIBS" != "x" -a "x[$]cu_$2_libdir" != "x"; then
                for cu_dir in [$]cu_$2_libdir; do
                        if test -r $cu_dir/lib$4.a; then
                                $1_STATIC_LIB=$cu_dir/lib$4.a
                                break
                        fi
                done
                for cu_dir in [$]cu_$2_libdir; do
                        if test -r $cu_dir/lib$4.so; then
                                $1_SHARED_LIB=$cu_dir/lib$4.so
                                break
                        fi
                done
        fi
        AC_SUBST($1_STATIC_LIB)
        AC_SUBST($1_SHARED_LIB)
else
        CU_WARN_NOT_PRESENT([Not using $3], $2, $6)
fi
else
        AC_SUBST($1_DIR)
        if test "x[$]USE_$1" != "xno"; then 
                CU_WARN_NOT_TESTED([Not testing whether $3 works], $2, $6)
        fi
fi
])


dnl CU_CHECK_TCL
dnl Special-case for Tcl code.  We want to load tclConfig.sh, then locate
dnl an appropriate libtclXXX and include path.
AC_DEFUN(CU_CHECK_TCL,
[AC_ARG_WITH(tcl,
[  --with-tcl=\$dir          use Tcl, finding tclConfig.sh in \$dir],
        TCL_DIR=$withval)
AC_ARG_WITH(tclincludes,
[  --with-tclincludes=\$dir  directory for Tcl includes, if not \$TCL_PREFIX/include],
        TCL_INCLUDE_DIR=$withval)
if test "x${TCL_DIR}" != "x"; then
        AC_MSG_CHECKING(whether to use Tcl)
        if test "x${TCL_DIR}" != "xno"; then
                cu_cv_use_tcl="yes"
        else
                cu_cv_use_tcl="no"
        fi
        AC_MSG_RESULT(${cu_cv_use_tcl})
else
        AC_CACHE_CHECK(whether to use Tcl, cu_cv_use_tcl,
                cu_cv_use_tcl="no")
fi
USE_TCL=${cu_cv_use_tcl}
AC_SUBST(USE_TCL)
AC_SUBST(TCL_DIR)
if test "x${cu_cv_use_tcl}" != "xno"; then
        if test "x${TCL_DIR}" != "xyes" -a "x${TCL_DIR}" != "x"; then
                AC_MSG_CHECKING(directory for Tcl)
                cu_cv_tcl_dir=${TCL_DIR}
                AC_MSG_RESULT(${cu_cv_tcl_dir})
                unset cu_cv_tcl_include_dir
        else
                AC_CACHE_CHECK(directory for Tcl, cu_cv_tcl_dir,
                        cu_cv_tcl_dir="unknown")
        fi
        if test "x$cu_cv_tcl_dir" != "xunknown"; then
                if test \! -r $cu_cv_tcl_dir/tclConfig.sh; then
                        CU_WARN_NOT_PRESENT([Could not find tclConfig.sh],
                                tcl, [<http://www.scriptics.com>])
                else
                        . $cu_cv_tcl_dir/tclConfig.sh
                fi
        fi
        if test "x${TCL_INCLUDE_DIR}" != "x"; then
                cu_cv_tcl_include_dir="$TCL_INCLUDE_DIR"
        fi
        AC_CACHE_CHECK(directory for Tcl includes, cu_cv_tcl_include_dir,
                [if test "x$TCL_PREFIX" = "x"; then
                        cu_cv_tcl_include_dir=unknown
                else
                        cu_cv_tcl_include_dir="$TCL_PREFIX/include"
                fi])
        if test "x$cu_cv_tcl_include_dir" != "xunknown"; then
                CPPFLAGS="$CPPFLAGS -I$cu_cv_tcl_include_dir"
        fi

dnl Forget the cached setting of whether tcl.h is present
        unset ac_cv_header_tcl_h

        AC_CHECK_HEADER(tcl.h, , AC_MSG_WARN(
[Unable to locate tcl.h.  Please make sure that --with-tcl
and --with-tclincludes are specified correctly.]))
        if test "x$TCL_LIB_SPEC" != "x"; then
                TCLLIBS=$TCL_LIB_SPEC
                AC_SUBST(TCLLIBS)
        fi
else
        CU_WARN_NOT_TESTED([Not testing whether Tcl works], tcl,
                                [<http://www.scriptics.com>])
fi
dnl Check for TCLLIBS and define USE_TCL macro
if test "x$TCL_DIR" != "x"; then
        AC_DEFINE(USE_TCL, 1,
        [Define if Tcl is to be used])
fi])


dnl CU_CHECK_GETHOSTBYNAME_R
dnl Check if we have gethostbyname_r; if so, check whether it uses
dnl Linux-style or Solaris-style calling conventions
AC_DEFUN(CU_CHECK_GETHOSTBYNAME_R,
[cu_save_LIBS=$LIBS
LIBS="$SOCKLIBS $LIBS"
AC_CHECK_FUNC(gethostbyname_r, [
AC_CACHE_CHECK(how to call gethostbyname_r, cu_cv_func_gethostbyname_r_params,
dnl Solaris-style gethostbyname_r
[AC_TRY_RUN([
#include <netdb.h>
#include <netinet/in.h>

int main() {
  struct hostent *hep = NULL;
  struct hostent host_e;
  char databuf[1024];
  int h_errno;
  
  hep = gethostbyname_r("localhost", &host_e, databuf, sizeof(databuf),
                        &h_errno);
  if (hep != NULL &&
      ntohl(((struct in_addr *)(hep->h_addr_list[0]))->s_addr) == 0x7f000001)
    return 0;

  return 1;
}
], cu_cv_func_gethostbyname_r_params=retval_as_ret,
dnl Linux-style gethostbyname_r
[AC_TRY_RUN([
#include <netdb.h>
#include <netinet/in.h>

int main() {
  struct hostent *hep = NULL;
  struct hostent host_e;
  char databuf[1024];
  int h_errno;
  
  gethostbyname_r("localhost", &host_e, databuf, sizeof(databuf),
                  &hep, &h_errno);
  if (hep != NULL &&
      ntohl(((struct in_addr *)(hep->h_addr_list[0]))->s_addr) == 0x7f000001)
    return 0;

  return 1;
}
], cu_cv_func_gethostbyname_r_params=retval_as_ptr,
dnl OSF1-style gethostbyname_r
[AC_TRY_RUN([
#include <netdb.h>
#include <netinet/in.h>
#include <string.h>

int main() {
  struct hostent *hep = NULL;
  struct hostent host_e;
  struct hostent_data host_d;
  int ret;

  memset(&host_d, 0, sizeof(host_d));
  ret = gethostbyname_r("localhost", &host_e, &host_d);
  hep = &host_e;
  if (ret == 0 &&
      ntohl(((struct in_addr *)(hep->h_addr_list[0]))->s_addr) == 0x7f000001)
    return 0;

  return 1;
}
], cu_cv_func_gethostbyname_r_params=osf1_deprecated,
cu_cv_func_gethostbyname_r_params=unknown,
cu_cv_func_gethostbyname_r_params=unknown)],
cu_cv_func_gethostbyname_r_params=unknown)],
cu_cv_func_gethostbyname_r_params=unknown)])

if test "x$cu_cv_func_gethostbyname_r_params" != "xunknown"; then
        AC_DEFINE(HAVE_GETHOSTBYNAME_R, 1,
                [Define if you have the gethostbyname_r function])
        HAVE_GETHOSTBYNAME_R=yes
else
        HAVE_GETHOSTBYNAME_R=no
fi
if test "x$cu_cv_func_gethostbyname_r_params" = "xretval_as_ptr"; then
        AC_DEFINE(GETHOSTBYNAME_R_RETVAL_AS_PTR, 1,
        [Define if gethostbyname_r returns its value through a pointer (Linux-style)])
fi
if test "x$cu_cv_func_gethostbyname_r_params" = "xosf1_deprecated"; then
        AC_DEFINE(GETHOSTBYNAME_R_OSF1_DEPRECATED, 1, 
        [Define if gethostbyname_r is missing some arguments (OSF1-style)])
fi
], [
        HAVE_GETHOSTBYNAME_R=no])
LIBS=$cu_save_LIBS
AC_SUBST(HAVE_GETHOSTBYNAME_R)
])


dnl CU_UTMP_UT_SYSLEN -- check if struct utmp[x] has ut_syslen and
dnl ut_type fields
AC_DEFUN(CU_CHECK_UTMP_FIELDS,
[
CU_CHECK_UTMP_FIELD(ut_syslen)
CU_CHECK_UTMP_FIELD(ut_type)
CU_CHECK_UTMP_FIELD(ut_name)
CU_CHECK_UTMP_FIELD(ut_user)
])

dnl helper function for the above
AC_DEFUN(CU_CHECK_UTMP_FIELD,
[if test "x$ac_cv_header_utmpx_h" = "x"; then
        AC_CHECK_HEADER(utmpx.h)
fi
if test "x$ac_cv_header_utmpx_h" = "xyes"; then
        cu_utmp=utmpx
else
        cu_utmp=utmp
fi
AC_CACHE_CHECK([whether struct $cu_utmp has $1], cu_cv_utmp_$1,
[
AC_TRY_COMPILE([#include <sys/types.h>
#include <$cu_utmp.h>],
[struct $cu_utmp *ut;
  extern void foo();
  foo(ut->$1);], cu_cv_utmp_$1=yes, cu_cv_utmp_$1=no)])

if eval "test \"x`echo '$cu_cv_utmp_'$1`\" = xyes"; then
        cu_tr_field=HAVE_UTMP_`echo $1 | sed -e \
               'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
       AC_DEFINE_UNQUOTED($cu_tr_field)
fi
])


dnl CU_CHECK_PTHREADS -- figure out how to use pthreads on this platform
AC_DEFUN(CU_CHECK_PTHREADS,
[
AC_REQUIRE([AC_CANONICAL_HOST])
AC_MSG_CHECKING(how to compile with pthreads)

case "$host" in
        *-*-solaris*)
               need__reentrant=yes
               LIBS="-lpthread $LIBS"
               AC_MSG_RESULT(-D_REENTRANT; -lpthread)
               ;;
       *-*-linux*)
               need__reentrant=yes
               LIBS="-lpthread $LIBS"
               AC_MSG_RESULT(-D_REENTRANT; -lpthread)
               ;;
       *-*-freebsd*)
               need__reentrant=yes
               need__thread_safe=yes
               LDFLAGS="-pthread $LDFLAGS"
               AC_MSG_RESULT(-D_REENTRANT -D_THREAD_SAFE; -pthread)
               ;;
       *)
               need__reentrant=yes
               LIBS="-lpthread $LIBS"
               AC_MSG_RESULT(unknown system.  Guessing: -D_REENTRANT; -lpthread)
esac

dnl autoheader gets grumpy if we AC_DEFINE things more than once, so
dnl add a level of indirection here.
if test "x$need__reentrant" = xyes; then
        AC_DEFINE(_REENTRANT, 1,
                [Define if you need this symbol for multi-threaded programs])
fi
if test "x$need__thread_safe" = xyes; then
        AC_DEFINE(_THREAD_SAFE, 1,
                [Define if you need this symbol for multi-threaded programs])
fi
])

dnl CU_CHECK_BOOLEAN_T -- define HAVE_BOOLEAN_T if it's in <sys/types.h>
dnl or a few other obvious places
AC_DEFUN(CU_CHECK_BOOLEAN_T,
[AC_REQUIRE([AC_HEADER_STDC])dnl
AC_MSG_CHECKING(for boolean_t)
AC_CACHE_VAL(cu_cv_have_boolean_t,
[AC_EGREP_CPP(dnl
changequote(<<,>>)dnl
<<(^|[^a-zA-Z_0-9])boolean_t[^a-zA-Z_0-9]>>dnl
changequote([,]), [#include <sys/types.h>
#if STDC_HEADERS
#include <stdlib.h>
#include <stddef.h>
#endif], cu_cv_have_boolean_t=yes, cu_cv_have_boolean_t=no)])dnl
AC_MSG_RESULT($cu_cv_have_boolean_t)
if test $cu_cv_have_boolean_t = yes; then
  AC_DEFINE(HAVE_BOOLEAN_T, 1, 
        [Define if <sys/types.h> defines boolean_t])
fi
])

dnl CU_CHECK_SASR -- check whether >> is a signed arithmetic shift.
dnl Needed for GSM libraries.
AC_DEFUN(CU_CHECK_SASR,
[AC_MSG_CHECKING([whether >> is a signed arithmetic shift])
AC_CACHE_VAL(cu_cv_rightshift_is_signed_arithmetic,
[AC_TRY_COMPILE(
changequote(`,')dnl
`',
`char foo[((-1 >> 1) == -1 ? 1 : -1)];',
changequote([,])dnl
cu_cv_rightshift_is_signed_arithmetic=yes,
cu_cv_rightshift_is_signed_arithmetic=no)])dnl
AC_MSG_RESULT($cu_cv_rightshift_is_signed_arithmetic)
if test "$cu_cv_rightshift_is_signed_arithmetic" = "yes"; then
  AC_DEFINE(RIGHTSHIFT_IS_SASR, 1,
        [Define if >> is a signed arithmetic shift])
fi
])

dnl
dnl Add a search path to the LIBS and CFLAGS variables
dnl
AC_DEFUN(AC_ADD_SEARCH_PATH,[
  if test "x$1" != x -a -d $1; then
     if test -d $1/lib; then
       LDFLAGS="-L$1/lib $LDFLAGS"
     fi
     if test -d $1/include; then
        CPPFLAGS="-I$1/include $CPPFLAGS"
     fi
  fi
])

dnl
dnl Check for several platform dependent socket lib stuff
dnl
dnl check for getaddrinfo, and other related functions.
AC_DEFUN(CU_CHECK_SOCKLIB, [
AC_CHECK_LIB(socket, socket)
AC_CHECK_LIB(nsl, gethostbyname)
AC_CHECK_FUNCS(getaddrinfo getnameinfo inet_pton inet_ntop)
AC_MSG_CHECKING(whether this platform supports IPv6)
ipv6="no"
AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>],
[int i;
 i = socket(AF_INET6, SOCK_DGRAM, 0);
 close(i);
],
[ipv6="yes"],
AC_DEFINE(NO_INET6, 1, [Define if you have IPv6]))
AC_MSG_RESULT($ipv6)

AC_MSG_CHECKING(whether in_port_t is defined)
in_port_t="yes"
AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>],  
[in_port_t p; 
 unsigned short s; 
 p = 0x9999; 
 s = htons(p);
], 
AC_DEFINE(HAVE_IN_PORT_T, 1, [Define if you have in_port_t]), 
[in_port_t="no"])
AC_MSG_RESULT($in_port_t)

AC_MSG_CHECKING(whether callers to getnameinfo need to set sa_len)
sa_len="yes"
AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>], 
[struct sockaddr s;
 s.sa_len = sizeof(struct sockaddr);
 return 0;
], 
AC_DEFINE(HAVE_SA_LEN, 1, [Define if sockaddr has sa_len]), 
[sa_len="no"])
AC_MSG_RESULT($sa_len)
])
