#! /bin/sh
# Default values
depdir=""
out="/tmp/dep$$"
outtemp="yes"

while true
do
    i=$1
    case "$i"
    in
        -d)
            depdir="$2"; shift;
            shift;;
        -o)
            out="$2"; outtemp="no";
            if test "x$depdir" = "x"
            then
                depdir=`dirname $2`;
            fi
            shift; shift;;
        --)
            shift; break;;
        *)
            break;;
    esac
done

if test "x$depdir" = "x"
then
    depdir="."
fi

if test \! -d $depdir
then
        echo mkdir -p $depdir 1>&2
        mkdir -p $depdir
fi

${REAL_CC:-${CC:-gcc}} -M $* > $out.tmp
save=$?
if test $save != 0; then
    rm -f $out.tmp
    cat /dev/null > $out
    exit
fi

sed -e 's| /[^ ]*||g' \
    -e "s|^\(.*\)\.o:|$depdir/\1.d $depdir/\1.o:|" \
    -e '/^ *\\$/d' \
    $out.tmp > $out

rm -f $out.tmp

if test "$outtemp" = "yes"
then
    cat $out
    rm -f $out
fi
