/*
 * bidipopen.c: open a bi-directional pipe to a sub-process.
 * Equivalent of popen(), except that popen(..., "r+") isn't implemented on
 * all systems (most notably Solaris).
 */

/* Copyright 2001 Columbia University.  All rights reserved */

typedef struct {
  FILE *file_r; /* File pointer for read */
  FILE *file_w; /* File pointer for write */
  pid_t pid;
} bidipipe;

extern bidipipe *  bidipopen (const char *command, const char *type);
extern int         bidipclose(bidipipe *iop);


