/* bitmap.h -- implement simple bitmap functions. */
/* Copyright 2001 Columbia University.  All rights reserved. */

#ifndef BITMAP_H_
#define BITMAP_H_

#include <limits.h>

/* bitmap */
typedef unsigned long bitmap_t;

#define BITMAP_MAX ((CHAR_BIT * sizeof(bitmap_t)) - 1)

#define setbit(map, bit) ((map) |= 1L << (bit))
#define clearbit(map, bit) ((map) &= ~(1L << (bit)))

#define setmap(map) ((map) = ~(0L))
#define clearmap(map) ((map) = 0L)

#define bitisset(map, bit) (((map) & (1L << (bit))) != 0)

#endif /* BITMAP_H_ */
