/* conf-util.h - Common utility functions for configuration etc;
 * (c) 2001 Columbia University. All rights reserved.
*/
#ifndef CONFUTIL_H_
#define CONFUTIL_H_

/* 
 * GetDBURI
 *  Try to get a usable database uri.
 * 
 *  This function looks into the file 'filename' for a Database URI.
 *  If it is not present or filename is NULL, it tries cinema_db.conf
 *  in the current directory. As a last step it tries /etc/cinema_db.conf
 *  in Unix platforms if all these fail. In Windows systems, it tries
 *  the registry key \\HKEY_LOCAL_MACHINE\SOFTWARE\Columbia University\
 *  IRT\Cinema\CINEMA_DB
 *
 *  It returns the uri string if found, or NULL. 
*/
char* GetDBURI(const char* filename); 

#endif

