#ifndef ERROR_H
#define ERROR_H
#include <sys/types.h>
#include <sys/socket.h>       /* struct sockaddr ... */

#ifdef __GNUC__
/* This function uses printf-style formats, so tell GNUC to do printf
 * format checking. */
#define ATTRIBUTE_PRINTF(fmt, args) \
   __attribute__ ((format (printf, fmt, args)))
#else
#define ATTRIBUTE_PRINTF(fmt, args)
#endif
extern void debug(const char *function_name, const char *format, ...)
     ATTRIBUTE_PRINTF(2, 3);
extern void debug2(const char *function_name, const struct sockaddr* sin, 
                   const char* format, ...)
     ATTRIBUTE_PRINTF(3, 4);
extern void fatal(const char *function_name, const char *format, ...)
     ATTRIBUTE_PRINTF(2, 3);
extern void error(const char *function_name, const char *format, ...)
     ATTRIBUTE_PRINTF(2, 3);
extern void ErrorInit(const char *file);
extern void ErrorClose(void);
#undef ATTRIBUTE_PRINTF


#endif
