/* fullpath.c.  Resolve a relative path into an absolute path.  Leave
 * absolute paths and pipelines alone. */

/* Copyright 1998-2001 Columbia University.  All rights reserved */

#include <stdio.h>
#include <limits.h>
#include <string.h>
#include <stdlib.h>
#include "sysdep.h"

#include "fullpath.h"

char *fullpath(const char *root, const char *filename)
{
  static char tmp[PATH_MAX];
  if (filename) {
    if (*filename == DIR_SEPARATOR[0] || *filename == '|') {
      strcpy(tmp, filename);
    }
    else if (strlen(root) + strlen(filename) + 1 < PATH_MAX)
      sprintf(tmp, "%s%s%s", root, DIR_SEPARATOR, filename);
    else {
      strcpy(tmp, "file_name_too_long");
    }
  }
  return tmp;
} /* fullpath */



char *fullpath_r(const char *root, const char *filename)
{
  char *tmp=NULL;
  
  if (filename) {
    if (*filename == DIR_SEPARATOR[0] || *filename == '|') {
      return strdup(filename);
    }
     
    tmp = malloc((strlen(root) + strlen(DIR_SEPARATOR)
                  + strlen(filename) + 1)); 
    if (tmp){
      sprintf(tmp, "%s%s%s", root, DIR_SEPARATOR, filename);
    }
  }
  return tmp;
} /* fullpath_r */
