/*
 * glob2regex.h
 * Convert a 'glob' pattern (of the form accepted by gmatch) to a 'regex'
 * extended pattern (of the form accepted by Posix regcomp()/regexec() with
 * the REG_EXTENDED flag).
 */

/* Copyright 2001 Columbia University.  All rights reserved. */

#include <regex.h>

int glob2regex(const char *glob, char **regex_p, int paren_prefix,
               int *suffix_offset);

size_t glob2regex_regerror(int errcode, const regex_t *preg,
                           char *errbuf, size_t errbuf_size);
