/*
* Convert symbolic group name to numeric id.
* Borrowed from Apache.
*/

#include <sys/types.h>
#include <unistd.h>
#include <grp.h>
#include <stdlib.h>     /* atoi() */
#include <string.h>     /* strlen() */
#include "error.h"
#include "sysdep.h"

gid_t gname2id(const char *name)
{
  struct group *ent;
 
  if (!name) return 0;
  if (name[0] == '#' && strlen(name) > 1)
    return(atoi(&name[1]));
 
  if (!(ent = getgrnam(name))) {
    fatal("gname2id", "bad group name %s", name);
  }
  return(ent->gr_gid);
} /* gname2id */
