#ifndef SERVERS_H
#define SERVERS_H
#include "afi.h"

typedef struct server_t {
  char *host;              /* host name */
  int type;                /* SOCK_DGRAM or SOCK_STREAM */
  struct sockaddr_storage sin;  /* IP address and port */
  int preference;          /* MX and SRV preference value (lower is better) */
  int weight;              /* load balancing weight (higher is better) */
} server_t;

extern server_t *servers(const char *domain, const char *service,
                         int type, int default_port);
#endif
