#include <stdlib.h>
#include <string.h>
#include "sysdep.h"
#include "strdupn.h"

char *strdupn(const char *string, int n)
{
  char *s = malloc(n+1);
  memcpy(s, string, n);
  s[n] = '\0';
  return s;
} /* strdupn */


/*
* Copy s2 to s1, after allocating new memory for it.
*/
void strassign(char **s1, const char *s2)
{
  if (*s1) free(*s1);
  *s1 = s2 ? strdup(s2) : NULL;
} /* strassign */


/*
 * strcompare()
 * test if two (possibly NULL) char*'s refer to equal null-terminated
 * strings.  Return <, =, or > 0, using the same logic as strcmp or
 * strcasecmp.  NULL strings are greater than everything else, to support
 * the common "list of strings terminated by NULL" idiom.  Use
 * case-insensitive matching if 'casefold'. 
 */
int strcompare(const char *first, const char *second, int casefold)
{
  if (first == NULL && second == NULL)
    return 0;
  else if (first == NULL)
    return 1;
  else if (second == NULL)
    return -1;
  else if (casefold)
    return strcasecmp(first, second);
  else
    return strcmp(first, second);
} /* strcompare */

   
/*
* Free if non-zero.
*/
void free_valid(void *p)
{
  if (p) free(p);
} /* free_valid */
