#ifndef TCP_H_
#define TCP_H_

#include "afi.h"                /* sockaddr_storage */

struct socket_info {
  int socket;                   /* socket number */
  struct sockaddr_storage sin;  /* name of peer */
  void *server;                 /* server object associated with this. */
};

/* tcp_thread_arg
 *  used for passing argument to the TCP thread 
*/
struct tcp_thread_arg {  
  unsigned short port;
  char *primaryIP;              /* use instead of INADDR_ANY, can be null */
  char *primaryIP6;             /* use intead of inaddr6_any, can be null */
  void *server;                 /* Server object pointer */
};

extern void *ReceiveTCPRequests(void *arg);
extern void *ReceiveTCP(void *arg);

#endif /* TCP_H_ */

