/*
* uname2id.c - Convert symbolic user name to numeric id.
* Borrowed from Apache.
*/

#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <stdlib.h>     /* atoi() */
#include <string.h>     /* strlen() */
#include "error.h"
#include "sysdep.h"

uid_t uname2id(const char *name)
{
  struct passwd *ent;
 
  if (!name) return 0;
  if (name[0] == '#' && strlen(name) > 1)
    return(atoi(&name[1]));
 
  if (!(ent = getpwnam(name))) {
    fatal("uname2id", "bad user name %s", name);
  }
  return ent->pw_uid;
} /* uname2id */
