# Columbia SIP makefile fragment for dbapi
# Copyright 1999-2000 by Columbia University; all rights reserved 

dbapi_dir := libdb++

DBAPI_SRC := \
  $(dbapi_dir)/mysqlconn.cpp \
  $(dbapi_dir)/dbaccess.cpp \
  $(dbapi_dir)/cinema_table.cpp \
  $(dbapi_dir)/cinema_dummy_table.cpp \
  $(dbapi_dir)/cinema_file_table.cpp 

ifeq ($(USE_MYSQL),yes)
DBAPI_SRC += \
  $(dbapi_dir)/cinema_mysql_table.cpp \
  $(dbapi_dir)/cinema_fastsql_cache.cpp 
endif

DBAPI_MAYBESRC := \
  $(dbapi_dir)/cinema_mysql_table.cpp \
  $(dbapi_dir)/cinema_fastsql_cache.cpp 

DBAPI_HEADERS := \
  $(dbapi_dir)/mysqlconn.h \
  $(dbapi_dir)/dbaccess.h \
  $(dbapi_dir)/cinema_table.h \
  $(dbapi_dir)/cinema_dummy_table.h \
  $(dbapi_dir)/cinema_file_table.h \
  $(dbapi_dir)/cinema_fastsql_table.h \
  $(dbapi_dir)/cinema_fastsql_cache.h \
  $(dbapi_dir)/cinema_mysql_table.h \
  $(dbapi_dir)/dbapi.h

DBAPI_MISC := \
  $(dbapi_dir)/module.mk \
  $(dbapi_dir)/libdbapi.dsp

DBAPI_MISCDIST :=

DBAPI_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(DBAPI_SRC))) \
	$(patsubst %.cpp,%.o,$(filter %.cpp,$(DBAPI_SRC)))

# How other parts of the build find us.
# Target to make:
DBAPI := $(dbapi_dir)/libdb++.a

# Add a target for building db++.
.PHONY: db++
db++ : $(DBAPI)

# Incantations for compile and build:
DBAPI_INC := -I$(topsrcdir)/$(dbapi_dir)
DBAPI_LIB := -L$(dbapi_dir) -ldb++

# Include directories required locally.
$(dbapi_dir)-CFLAGS := $(LIBCINE_INC) $(LIBDICT_INC) 

DBAPI_REQS := need-mysql

# Do not include it in all:
# all: $(DBAPI)

$(DBAPI): $(DBAPI_OBJ)
	@echo "creating library $@..."
	@$(AR) rc $@ $^
	@$(RANLIB) $@

SRC       += $(DBAPI_SRC) $(DBAPI_OTHER_SRC)
HEADERS   += $(DBAPI_HEADERS)
MISC      += $(DBAPI_MISC) $(DBAPI_MAYBESRC)
MISCDIST  += $(DBAPI_MISCDIST)
MISCCLEAN += $(DBAPI) $(DBAPI_OTHER_MISCCLEAN)

DBAPI_MODULES := test

# Include the description for each sub-module
include $(patsubst %,$(topsrcdir)/$(dbapi_dir)/%/module.mk,$(DBAPI_MODULES))

# Various distributions.

# Files for distributions:
DBAPI_DIST := $(DBAPI_SRC) $(DBAPI_MAYBESRC) $(DBAPI_HEADERS) \
             $(DBAPI_MISC) $(DBAPI_MISCDIST) $(DBAPI_TEST_DIST)
