# Makefile fragment for dbapi tests
# Copyright 1998-1999 by Columbia University; all rights reserved 

dbapi_test_dir := $(dbapi_dir)/test

DIRS += $(dbapi_test_dir)


DBAPI_TEST_BIN := \
	$(dbapi_test_dir)/dbaccess-test \
	$(dbapi_test_dir)/dbaccess-test-c


DBAPI_TEST_SRC := \
	$(dbapi_test_dir)/dbaccess-test.cpp \
	$(dbapi_test_dir)/dbaccess-test-c.c


DBAPI_TEST_MISC := \
	$(dbapi_test_dir)/module.mk


DBACCESS_TEST_OBJS := \
	$(dbapi_test_dir)/dbaccess-test.o

DBACCESS_TEST_C_OBJS := \
	$(dbapi_test_dir)/dbaccess-test-c.o

DBACCESS_TEST_LIBS := $(DBAPI_LIB) $(MYSQLLIBS) $(ZLIBLIBS) \
	$(LIBDICT_LIB) $(LIBCINE_LIB) $(SOCKLIBS) $(MATHLIBS)

# Include directories required locally
$(dbapi_test_dir)-CFLAGS := $(DBAPI_INC) $(LIBCINE_INC)

DBAPI_TEST_DEPENDENCIES := $(DBAPI) $(LIBCINE) $(LIBDICT)

test: $(dbapi_test_dir)/dbaccess-test $(dbapi_test_dir)/dbaccess-test-c

$(dbapi_test_dir)/dbaccess-test: $(dbapi_test_dir)/dbaccess-test.o $(DBAPI_TEST_DEPENDENCIES)
	@echo "linking $@..."
	$(CXX) -o $@ $(CFLAGS) $(LDFLAGS) $(DBACCESS_TEST_OBJS) $(DBACCESS_TEST_LIBS) $(LIBS)

$(dbapi_test_dir)/dbaccess-test-c: $(dbapi_test_dir)/dbaccess-test-c.o $(DBAPI_TEST_DEPENDENCIES)
	@echo "linking $@..."
	$(CXX) -o $@ $(CFLAGS) $(LDFLAGS) $(DBACCESS_TEST_C_OBJS) $(DBACCESS_TEST_LIBS) $(LIBS)

BIN += $(DBAPI_TEST_BIN)
SRC += $(DBAPI_TEST_SRC)
HEADERS += $(DBAPI_TEST_HEADERS)

DBAPI_TEST_DIST := $(DBAPI_TEST_SRC) $(DBAPI_TEST_HEADERS) $(DBAPI_TEST_MISC) \
	$(DBAPI_TEST_MISCDIST)

# These test binaries don't need to go in the bindist
DBAPI_TEST_BINDIST := $(DBAPI_TEST_MISCDIST)
