# Columbia CINEMA servers makefile fragment for libdict
# Copyright 1998-1999 by Columbia University; all rights reserved 

libdict_dir := libdict

LIBDICT_SRC := \
  $(libdict_dir)/dict.c \
  $(libdict_dir)/fsma.c \
  $(libdict_dir)/ht.c

LIBDICT_HEADERS := \
  $(libdict_dir)/dict.h \
  $(libdict_dir)/dictimpl.h \
  $(libdict_dir)/fsma.h \
  $(libdict_dir)/ht.h \
  $(libdict_dir)/htimpl.h \
  $(libdict_dir)/impl.h


LIBDICT_MISC := \
  $(libdict_dir)/module.mk \
  $(libdict_dir)/libdict.dsp \
  $(libdict_dir)/COPYRIGHT \
  $(libdict_dir)/dict.3 \
  $(libdict_dir)/fsma.3 \
  $(libdict_dir)/ht.3

LIBDICT_MISCCLEAN := \
  $(libdict_dir)/libdict.a

LIBDICT_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(LIBDICT_SRC)))

LIBDICT_DEP := \
	$(LIBDICT_OBJ:.o=.d)


# How other parts of the build find us:
# Target for make:
LIBDICT := $(libdict_dir)/libdict.a

# Incantations for compile and build:
LIBDICT_INC := -I$(topsrcdir)/$(libdict_dir)
LIBDICT_LIB := -L$(libdict_dir) -ldict


$(LIBDICT): $(LIBDICT_OBJ)
	@echo "creating library $@..."
	$(AR) rc $@ $^
	$(RANLIB) $@

SRC       += $(LIBDICT_SRC) $(LIBDICT_OTHER_SRC)
HEADERS   += $(LIBDICT_HEADERS)
MISCCLEAN += $(LIBDICT_MISCCLEAN)

LIBDICT_DIST := $(LIBDICT_SRC) $(LIBDICT_OTHER_SRC) \
	$(LIBDICT_HEADERS) $(LIBDICT_MISC)
