/*
 * Canonicalize.c
 * Given a URI, return a canonicalized version of the same URI,
 * suitable for database lookups.
 */

/* Copyright 2001 Columbia University.  All rights reserved. */

#ifndef CANONICALIZE_H_
#define CANONICALIZE_H_

#include "canonicalizer_interface.h"

extern int canonicalize_init(void);
extern int canonicalize_terminate(void);

extern int canonicalize(const uri_t *uri, canon_result *result);

extern void free_canon_result(canon_result *result);

#endif /* CANONICALIZE_H_ */
