/*
license.h - handles license validations for CINEMA software.

Copyright 1998-2001 by Columbia University; all rights reserved 
*/
#ifndef LICENSE_H_
#define LICENSE_H_
typedef struct {
  char *license_uri;      /* e.g. sql://user:password@host/sip, can be 
                           * file://license_file_name for file based
                           * license checking
                          */
  char *table_name;       /* e.g. sipd_license (for sipd) etc; will
                           * be NULL for file based licensing
                          */
  char *internal_code;    /* the md5 key.*/
} cinema_license_info;


/*
 * check_registration
 *  Checks whether a valid license exists for the host machine based
 * on File or DB license tables. Return 0 on success, -1 on 
 * license failure.
 */
int check_registration(const cinema_license_info *lic_info);

#endif /* LICENSE_H_ */
