/* log_interface.h --- libsip interface to log requests. 
   (c) 1999-2001 Columbia University. */
#ifndef LOG_INTERFACE_H_
#define LOG_INTERFACE_H_
#include <sys/types.h>                /* uint32_t ... */
#include "sysdep.h"
#include "request-common.h"           /* request_t */
/*
 * Interface to log sip requests.
 *
 * libsip will call the callback function, if one has been supplied
 * with the request_t pointer.
 * 
 * This facilitates the use of different log handlers. e.g, one
 * each for sipd and siplib.
 *
 * The LogData pointer should be initialized to a proper function
 * at startup for logging to work.
 */
extern void (*LogData)(request_t *r);

#endif /* log_interface.h */
