# Columbia CINEMA servers makefile fragment for libsip
# Copyright 1998-1999 by Columbia University; all rights reserved 

libsip_dir := libsip

LIBSIP_SRC := \
  $(libsip_dir)/authenticate.c \
  $(libsip_dir)/authenticateSIP.c \
  $(libsip_dir)/canonicalize.c \
  $(libsip_dir)/client.c \
  $(libsip_dir)/failure.c \
  $(libsip_dir)/message.c \
  $(libsip_dir)/policy_core.c \
  $(libsip_dir)/proxy-support.c \
  $(libsip_dir)/querydb.c \
  $(libsip_dir)/request.c \
  $(libsip_dir)/response.c \
  $(libsip_dir)/rr_support.c \
  $(libsip_dir)/sip.c \
  $(libsip_dir)/sipsnmp_interface.c \
  $(libsip_dir)/license.c \
  $(libsip_dir)/log_interface.c


LIBSIP_HEADERS := \
  $(libsip_dir)/authenticate.h \
  $(libsip_dir)/authenticateSIP.h \
  $(libsip_dir)/canonicalize.h \
  $(libsip_dir)/config.h \
  $(libsip_dir)/libsip.h \
  $(libsip_dir)/message.h \
  $(libsip_dir)/policy.h \
  $(libsip_dir)/proxy-support.h \
  $(libsip_dir)/querydb.h \
  $(libsip_dir)/request-sip.h \
  $(libsip_dir)/rr_support.h \
  $(libsip_dir)/sipsnmp_interface.h \
  $(libsip_dir)/log_interface.h \
  $(libsip_dir)/canonicalizer_interface.h \
  $(libsip_dir)/license.h \
  $(libsip_dir)/sip.h 



LIBSIP_MISC := \
  $(libsip_dir)/module.mk \
  $(libsip_dir)/libsip.dsp


LIBSIP_MISCCLEAN := \
  $(libsip_dir)/libsip.a


LIBSIP_OBJ := \
	$(patsubst %.c,%.o,$(filter %.c,$(LIBSIP_SRC)))

LIBSIP_DEP := \
	$(LIBSIP_OBJ:.o=.d)


# How other parts of the build find us:
# Target for make:
LIBSIP := $(libsip_dir)/libsip.a

# Incantations for compile and build:
LIBSIP_INC := -I$(topsrcdir)/$(libsip_dir)
LIBSIP_LIB := -L$(libsip_dir) -lsip $(CRYPTLIBS)

# Include directories required locally:
$(libsip_dir)-CFLAGS := $(LIBCINE_INC) $(LIBDICT_INC) $(DBAPI_INC)


$(LIBSIP): $(LIBSIP_OBJ)
	@echo "creating library $@..."
	$(AR) rc $@ $^
	$(RANLIB) $@

SRC       += $(LIBSIP_SRC) $(LIBSIP_OTHER_SRC)
HEADERS   += $(LIBSIP_HEADERS)
MISC      += $(LIBSIP_MISC) $(LIBSIP_MAYBESRC)
MISCDIST  += $(LIBSIP_MISCDIST)
MISCCLEAN += $(LIBSIP_MISCCLEAN)

# Files for distributions:
LIBSIP_DIST := $(LIBSIP_SRC) $(LIBSIP_MAYBESRC) $(LIBSIP_HEADERS) \
	$(LIBSIP_MISC)
