/*
 * proxy-support.h - useful functions for proxying a SIP request.
 * used by sipd/proxy.c, sipd/cgi.c, and libsip++/user.cpp.
 *
 * Copyright 1998-2001 by Columbia University; all rights reserved 
 */

#ifndef PROXY_SUPPORT_H_
#define PROXY_SUPPORT_H_

#include "request-sip.h"
#include "message.h"
#include "policy.h"

extern void SendBestResponse(request_t *r);
extern message_t *PickBestResponse(request_t *r, message_t *mq);
extern void ForwardACKToBranches(request_t *r, message_t *m);
extern void CancelUnfinishedBranches(request_t *r);
extern void ProxyDispatchResponse(request_t *r, message_t *m,
                                  policy_type type);
extern void StandardSubsequentRequestHandling(request_t *r, message_t *m);

#endif /* PROXY_SUPPORT_H_ */
