/*
 * querydb.h: Wrapper functions around dpapi.h to do the specific
 * functions needed by libsip/sipd
 */

/* Copyright 2000, 2001 Columbia University.  All rights reserved. */

#ifndef QUERYDB_H_
#define QUERYDB_H_

#include "request-sip.h"

#include "dbaccess.h"

/* Check if a return code means the database lookup failed unexpectedly. */
#define db_ret_invalid(db_ret)  ((db_ret) < -1000)

/*
 *Max time_t vaule for infinite time
 */
#define MAX_TIME_T  ((time_t) 0x7fffffff)


extern db_err method_allowed_for_user(const char *method,
                                      const put_table_entry *user);

extern db_err may_register_for(const put_table_entry *from_user,
                               const put_table_entry *to_user);

extern db_err get_pwinfo_for_user(const put_table_entry *user,
                                  char **hash_value,
                                  char **realm,
                                  char **algorithm);

extern db_err get_gwclass_for_user(const put_table_entry *user,
                                   char **gwclass);

extern db_err user_wants_request_authentication(const put_table_entry *user,
                                                int *required);


extern void request_set_dberr_status(request_t *r, db_err db_ret,
                                     const char *userid,
                                     int status_db_no,
                                     const char *reason_db_no);

extern char* time2dbstring(time_t time);
extern time_t dbstring2time(const char *string);

#endif /* QUERYDB_H_ */
