#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "iptelapi.h"
#include "string.h"
#include "ads.h"
#include "command.h"

#ifdef __cplusplus
extern "C" {
#endif

#include <sysdep.h>
#ifdef WIN32
char *strtok_r(char *s1, char *s2, char **lasts);
#endif
#ifdef __cplusplus
}
#endif

CommandObject::CommandObject(const char *cmd, GenericHeaders & g)
: GenericHeaders()
{
  if ( cmd == NULL ) {
    return;
  }

  char *ptr = strdup(cmd);
  char *o_ptr = ptr;
  char *lasts = NULL;
  char *line;
  GenericHeaders params;
  int state = 0;
  char *l2;
  char *p, *v;
  char strnum[10];

  argc = 0;
  paramc = 0;

  while ((line = strtok_r(ptr, " \r\n", &lasts)) != NULL && *line) {
    ptr = NULL;
    switch(state) {
    case 0: 
      headers.Append(GenericHeaderValue("command", line));
      state = 1;
      break;
    case 1:
      l2 = NULL;
      p = strtok_r(line, "=", &l2);
      v = strtok_r(NULL, " ", &l2);
      if ( v== NULL || *v == 0) {
        state = 2;
        argc ++;
        sprintf(strnum, "%d", argc);
        p = Normalize(p, g);
        headers.Append(GenericHeaderValue(strnum,p));
        free(p);
      }
      else {
        paramc ++;
        v = Normalize(v, g);
        params += GenericHeaderValue(p,v);
        free(v);
      }
      break;
    case 2:
      argc ++;
      sprintf(strnum, "%d", argc);
      line = Normalize(line, g);
      headers.Append(GenericHeaderValue(strnum,line));
      free(line);
    }
  }

  for (int i=0; i<params.GetSize(); i++) {
    headers.Append(GenericHeaderValue(params[i].GetType(),
                               params[i].GetValue()));
  }

  free(o_ptr);
}

char * CommandObject::Normalize(const char *p, GenericHeaders & g)
{
  /* If p is of the form [...] then get the appropriate value from
   * g and substitute. Otherwise just return a copy of p */
  if ( !p ) 
    return NULL;
  if ( *p == '[' && *(p + strlen(p)-1) == ']' ) {
    char *r;
    char * v = (char *)calloc(strlen(p)-1, 1);
    memcpy(v, (p+1), strlen(p)-1);
    *(v+strlen(p)-2) = 0;
    if ( v && *v && g[v] != NULL ) {
      r = strdup((const char *) g[v]);
    }
    else {
      r = NULL;
    }
    free(v);
    return r;
  }
  else {
    return strdup(p);
  }
}

CommandObject::operator const char * ()
{
  return (const char *)(*this)["command"];
}

bool CommandObject::operator==(const char * v)
{
  const char * str = (const char *)(*this)["command"];
  if ( v==NULL && (str == NULL || *str == 0)) {
    return true;
  }
  else if ( v==NULL ) {
    return false;
  }
  else {
    return strcasecmp((const char *)(*this)["command"], v) == 0; 
  }
}

int CommandObject::GetArgsCount()
{
  return argc;
}

bool CommandObject::IsParameter(int i, const char *p)
{
  const char * v = (const char *) (*this)[i];
  if ( v==NULL) {
    return false;
  }
  return strcasecmp(v,p) == 0;
}

static char mystring[1024];

const char *CommandObject::TillEnd(int index)
{
  int first_time = 1;
  strcpy(mystring, "");

  for ( int i=index; i < argc+1; i++) {
    if ( !first_time ) {
      strcat(mystring, " ");
    }
    else {
      first_time = 0;
    }
    strcat(mystring, (*this)[i]);
  }
  return mystring;
}

ostream & operator<<(ostream & o, CommandObject & addr)
{
  /* Do nothing right now. */
  return o;
}
